package com.example.reservationapp.screens

import android.widget.Toast
import androidx.compose.foundation.layout.Arrangement
import androidx.compose.foundation.layout.Column
import androidx.compose.foundation.layout.Spacer
import androidx.compose.foundation.layout.fillMaxSize
import androidx.compose.foundation.layout.height
import androidx.compose.foundation.layout.padding
import androidx.compose.foundation.shape.RoundedCornerShape
import androidx.compose.foundation.text.ClickableText
import androidx.compose.material.icons.Icons
import androidx.compose.material.icons.filled.Email
import androidx.compose.material3.Button
import androidx.compose.material3.Icon
import androidx.compose.material3.OutlinedTextField
import androidx.compose.material3.Text
import androidx.compose.material3.TextFieldDefaults
import androidx.compose.runtime.Composable
import androidx.compose.runtime.mutableStateOf
import androidx.compose.runtime.remember
import androidx.compose.ui.Alignment
import androidx.compose.ui.Modifier
import androidx.compose.ui.graphics.Color
import androidx.compose.ui.text.AnnotatedString
import androidx.compose.ui.tooling.preview.Preview
import androidx.compose.ui.unit.dp
import androidx.navigation.NavController
import androidx.compose.foundation.Image
import androidx.compose.foundation.layout.Box
import androidx.compose.foundation.layout.fillMaxWidth
import androidx.compose.foundation.layout.wrapContentHeight
import androidx.compose.foundation.layout.wrapContentSize
import androidx.compose.foundation.layout.wrapContentWidth
<<<<<<< HEAD
import androidx.compose.material3.CircularProgressIndicator
import androidx.compose.ui.platform.LocalContext
=======
import androidx.compose.foundation.text.KeyboardOptions
import androidx.compose.material.icons.filled.Phone
import androidx.compose.material3.CircularProgressIndicator
import androidx.compose.runtime.saveable.rememberSaveable
import androidx.compose.ui.draw.clip
import androidx.compose.ui.platform.LocalContext
import androidx.compose.ui.text.input.ImeAction
import androidx.compose.ui.text.input.KeyboardType
import androidx.compose.ui.text.style.TextAlign
>>>>>>> b52d68e (мне плохо)
import coil.compose.AsyncImage
import coil.compose.AsyncImagePainter
import coil.compose.rememberAsyncImagePainter
import coil.request.ImageRequest
import coil.size.Size
<<<<<<< HEAD
=======
import com.example.reservationapp.models.RegistrationForm
import com.example.reservationapp.viewmodels.NewViewModel
>>>>>>> b52d68e (мне плохо)

@Composable
fun Registration(navController: NavController, viewModel: NewViewModel) {
    Column ( modifier = Modifier
        .fillMaxSize()
        .padding(horizontal = 30.dp, vertical = 140.dp),
        verticalArrangement = Arrangement.Center,
        horizontalAlignment = Alignment.CenterHorizontally){

        val context = LocalContext.current

        var emailInput = remember {mutableStateOf("")}
        var nameInput = remember { mutableStateOf("")}
        var surnameInput = remember { mutableStateOf("")}
        var phoneNumber = remember { mutableStateOf("")}

        Text(text = "Nice to meet you.\nEnter your data here",
            textAlign = TextAlign.Center)

        Spacer(modifier = Modifier.height(30.dp))

<<<<<<< HEAD
        val imageState = rememberAsyncImagePainter(
            model = ImageRequest.Builder(LocalContext.current).data("https://localhost:7249/api/PhotoActions/16770218.jpg")
                .size(Size.ORIGINAL).build()
        ).state

        if (imageState is AsyncImagePainter.State.Error) {
            Box(
                modifier = Modifier
                    .fillMaxWidth()
                    .height(200.dp),
                contentAlignment = Alignment.Center
            ) {
                CircularProgressIndicator()
            }
        }

        if (imageState is AsyncImagePainter.State.Success){

            Image(
                painter = imageState.painter,
                contentDescription = "something",
                modifier = Modifier
                    .wrapContentSize()
                    .wrapContentHeight()
                    .wrapContentWidth()
                    .height(200.dp)
            )
        }

//        OutlinedTextField(
//            value = emailInput.value,
//            shape = RoundedCornerShape(20.dp),
//            colors = TextFieldDefaults.colors(
//                focusedContainerColor = Color.Green
//            ),
//            maxLines = 1,
//            onValueChange = {newText -> emailInput.value = newText},
//            label = { Text(text = "example@some.com") },
//            leadingIcon = {
//                Icon(imageVector = Icons.Default.Email,
//                    contentDescription = "email info")
//            }
//        )
=======
        OutlinedTextField(
            value = emailInput.value,
            shape = RoundedCornerShape(20.dp),
            singleLine = true,
            onValueChange = {newText -> emailInput.value = newText},
            label = { Text(text = "example@some.com") },
            leadingIcon = {
                Icon(imageVector = Icons.Default.Email,
                    contentDescription = "email info")
            },
            keyboardOptions = KeyboardOptions.Default.copy(
                keyboardType = KeyboardType.Email,
                imeAction = ImeAction.Next
            ),
        )
>>>>>>> b52d68e (мне плохо)

        Spacer(modifier = Modifier.height(30.dp))

        OutlinedTextField(
            value = nameInput.value,
            shape = RoundedCornerShape(20.dp),
            singleLine = true,
            onValueChange = {newText -> nameInput.value = newText},
            label = { Text(text = "Enter your name") },
            keyboardOptions = KeyboardOptions.Default.copy(
                keyboardType = KeyboardType.Text,
                imeAction = ImeAction.Next
            ),
        )

        Spacer(modifier = Modifier.height(30.dp))

        OutlinedTextField(
            value = surnameInput.value,
            shape = RoundedCornerShape(20.dp),
            singleLine = true,
            onValueChange = {newText -> surnameInput.value = newText},
            label = { Text(text = "Enter your surname") },
            keyboardOptions = KeyboardOptions.Default.copy(
                keyboardType = KeyboardType.Text,
                imeAction = ImeAction.Next
            ),

        )

        Spacer(modifier = Modifier.height(30.dp))

        OutlinedTextField(
            value = phoneNumber.value,
            shape = RoundedCornerShape(20.dp),
            onValueChange = {newText -> phoneNumber.value = newText},
            label = { Text(text =  "Phone number")},
            placeholder = { Text(text = "Phone Number")},
            leadingIcon = { Icon(Icons.Filled.Phone, contentDescription = "Phone number")},
            singleLine = true,
            keyboardOptions = KeyboardOptions.Default.copy(
                keyboardType = KeyboardType.Phone,
                imeAction = ImeAction.Done
            ),
        )

        Spacer(modifier = Modifier.height(30.dp))

        Button(onClick = { navController.navigate("OTPScreen") }) {
            Text(text = "Create OTP")
        }

        Button(
            onClick = {
                      var objReg = RegistrationForm(
                          emailInput.value, nameInput.value,
                          surnameInput.value, phoneNumber.value)

                       viewModel.sendTheRegForm(objReg)
                       var code = viewModel.sendEmailCodeProp

                        if (code == "200"){
                            Toast.makeText(context, "Я надеюсь на победу", Toast.LENGTH_SHORT).show()
                            viewModel.emailPut(emailInput.value)
                            navController.navigate("OTPScreen")
                        }


                      },

            modifier = Modifier
                .fillMaxSize(0.6f)
                .height(30.dp)
                .clip(RoundedCornerShape(10.dp))

        ) {
            Text(text = "Create account")
        }
        
//        val imageState = rememberAsyncImagePainter(
//            model = ImageRequest.Builder(LocalContext.current).
//            data("https://iis.ngknn.ru/ngknn/МамшеваЮС/7/api/PhotoActions/test2.jpg/get-photo")
//                .size(Size.ORIGINAL).build()
//        ).state
//
//        if (imageState is AsyncImagePainter.State.Error) {
//            Box(
//                modifier = Modifier
//                    .fillMaxWidth()
//                    .height(200.dp),
//                contentAlignment = Alignment.Center
//            ) {
//                CircularProgressIndicator()
//            }
//        }
//
//        if (imageState is AsyncImagePainter.State.Success){
//
//            Image(
//                painter = imageState.painter,
//                contentDescription = "something",
//                modifier = Modifier
//                    .wrapContentSize()
//                    .wrapContentHeight()
//                    .wrapContentWidth()
//                    .height(200.dp)
//            )
//        }




    }

}