package com.example.reservationapp.viewmodels

import androidx.lifecycle.LiveData
import androidx.lifecycle.ViewModel
import androidx.lifecycle.viewModelScope
import com.example.reservationapp.api.RepositoryClassCasual
import com.example.reservationapp.models.RegistrationForm
import kotlinx.coroutines.launch

class NewViewModel (private val repository: RepositoryClassCasual) : ViewModel() {

    val regCodeProp: String
        get() = repository.takeRegCode

    val sendEmailCodeProp: String
        get() = repository.takeCode

    val emailProp: String
        get () = repository.takeEmail

    val loginProp: String
        get() = repository.takeCode

    val JWTtokenhere: String
        get() = repository.reciveJWT

    fun emailPut(email: String){
        repository.emailUpload(email)
    }

    fun sendingCode(email: String){
        viewModelScope.launch {
            repository.sendEmail(email)
        }
    }

    fun sendTheRegForm(regObj: RegistrationForm){
        viewModelScope.launch {
            repository.sendMyFormReg(regObj)
        }
    }

    fun loginGetCode(email: String){
        viewModelScope.launch {
            repository.loginAction(email)
        }
    }

}